#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf dmidecode-2.11.tar.bz2
    cd dmidecode-2.11
    sed -i '/^CFLAGS += /d' Makefile
    make dmidecode
    strip -R .note -R .comment dmidecode
    mkdir -p ../dmidecode/bin
    cp dmidecode ../dmidecode/bin/
    cd ..
    rm -rf dmidecode-2.11
}

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
[ "$ARCH" != 'i386' -a "$ARCH" != 'amd64' ] && exit 0

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
